Object subclass: #CustomBlockDefinition
	instanceVariableNames: 'userSpec blockVars body isReporter isAtomic isBoolean answer category type declarations defaults isGlobal '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 7/19/2010 04:11'!
addBlockVariable

	| ans |
	ans _ StringDialog askWithCancel: 'New Block Variable Name' initialAnswer: ''.
	ans isEmpty ifTrue: [^false].
	(self allVarNames includes: ans) ifTrue: [
		DialogBoxMorph warn: 'This block variable name already exists'.
		^false ].
	blockVars add: ans.
	^true! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 6/14/2009 16:20'!
allBlocks
	| all |

	body
		ifNil: [ all _ OrderedCollection new]
		ifNotNil: [
			all _ body allMorphs select: [:m|
				m isKindOf: BlockMorph ]].

	(answer isKindOf: BlockMorph) ifTrue: [
		all _ all, answer allMorphs select: [:m |
		m isKindOf: BlockMorph ]].

	^all! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/24/2008 10:15'!
allVarNames
	^(self varNames, self parameterNames) asSortedCollection! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/22/2010 02:04'!
answer
	(answer respondsTo: #fullCopy)
		ifTrue: [^answer fullCopy].
	^answer! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 10/13/2008 14:29'!
answer: aBlockOrNumber
	answer _ aBlockOrNumber! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/5/2010 00:52'!
answerBlock
	| spec block |

	#boolean = type
		ifTrue: [spec _ 'answer %b']
		ifFalse: [spec _ 'answer %s'].
	
	block _ CommandBlockMorph new
		commandSpec: spec;
		isSpecialForm: true;
		selector: #doAnswer.

	(answer isKindOf: ReporterBlockMorph) ifTrue: [
		^block replaceArgMorph: (block argumentAt: 1) by: answer ].

	#boolean = type ifTrue: [^block].

	answer ifNil: [answer _ ''].

	(answer isKindOf: Array)
		ifTrue: [ block argMorphs first stringExpression: '']
		ifFalse: [block argMorphs first stringExpression: answer ].
	^block! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/7/2010 23:06'!
blockColor
	#none = category
		ifTrue: [^ Color lightGray]
		ifFalse: [^ ScriptableScratchMorph blockColorFor: category]! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/14/2010 22:48'!
blockVars: aCollection

	blockVars _ aCollection asSet! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/24/2008 13:00'!
body
	^body! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/29/2008 15:04'!
body: aBlock
	body _ aBlock.! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/4/2010 23:53'!
category

	"categories can be:

		#none	- a gray block in the variables palette (BYOB legacy)
		#motion
		#looks
		#sound
		#pen
		#control
		#sensing
		#operators
		#variables
	"

	^ category! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/4/2010 23:53'!
category: aSymbol

	"categories can be:

		#none	- a gray block in the variables palette (BYOB legacy)
		#motion
		#looks
		#sound
		#pen
		#control
		#sensing
		#operators
		#variables
	"

	category _ aSymbol! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/30/2008 09:44'!
commandSpec

	^self commandSpecFrom: userSpec! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 4/7/2010 00:53'!
commandSpecFrom: aUserSpec

	|cmd out pname ptype|
	cmd _ ScratchServer new parse: aUserSpec.
	out _ WriteStream on: String new. 
	cmd do: [:each|
		(each asString beginsWith: '%')
			ifTrue: [
				pname _ each asString allButFirst.
				ptype _ declarations at: pname ifAbsent: [#any].
				out nextPutAll: (self specFor: ptype) ]
			ifFalse: [out nextPutAll: each asString].
		out space ].
	^out contents withoutTrailingBlanks! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/4/2010 23:55'!
declarations
	^declarations! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/4/2010 23:55'!
declarations: aDictionary
	declarations _ aDictionary! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/20/2010 12:10'!
defaultOf: parameterName

	defaults ifNil: [defaults _ Dictionary new ].
	^ defaults at: parameterName ifAbsent: ['']! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/20/2010 12:12'!
defaults
	defaults ifNil: [defaults _ Dictionary new].
	^defaults! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/20/2010 01:03'!
defaults: aDictionary
	defaults _ aDictionary! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/29/2008 15:06'!
deleteBlockVariable
	| ans |
	ans _ (SelectionMenu selections: self varNames) startUp.
	ans ifNil: [^false].
	blockVars remove: ans.
	^true! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'JM 8/9/2011 15:52'!
englishSpec

	self type = #none ifTrue: [ ^ 'command' ].
	self type = #any ifTrue: [ ^ 'reporter' ].
	self type = #boolean ifTrue: [ ^ 'predicate' ].

	^ self halt. "You might need to add a msg id for this type of block :)"! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/14/2010 20:36'!
id
	^self class idFromSpec: userSpec! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/26/2008 12:29'!
isAtomic
	^isAtomic! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/29/2008 15:04'!
isAtomic: aBoolean
	isAtomic _ aBoolean.! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 3/3/2010 00:13'!
isGlobal
	^isGlobal ifNil: [isGlobal _ false]! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/25/2010 02:26'!
isGlobal: bool
	isGlobal _ bool! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/29/2008 16:03'!
parameterNames

	^self parameterNamesInSpec: userSpec! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/2/2010 00:29'!
parameterNamesInSpec: aString

	| cmd out |
	cmd _ ScratchServer new parse: aString asMacRoman.
	out _ OrderedCollection new.
	cmd do: [:each|
		(each asString beginsWith: '%')
			ifTrue: [out add: (each asString allButFirst) asUTF8]].
	^out asArray! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'JM 8/3/2011 16:51'!
specFor: typeSym
	 | specs |
	specs _ Dictionary new.
	specs
		at: #command put: '%o';
		at: #commandList put: '%O';
		at: #reporter put: '%r';
		at: #reporterList put: '%R';

"+++++++ deprecated experimental slots    -jens +++++++++++++

		at: #reporterSlot put: '%4';
		at: #reporterSlotList put: '%Q';
		at: #typeInReporter put: '%j';
		at: #typeInReporterList put: '%q';

+++++++++++++++++++++++++++++++++++++++++++++++++++++++++"

		at: #unevaluated put: '%j';
		at: #unevaluatedList put: '%q';
		at: #unevaluatedBoolean put: '%Q';
		at: #unevaluatedBooleanList put: '%4';

		at: #predicate put: '%6';
		at: #predicateList put: '%5';
		at: #list put: '%t';
		at: #listList put: '%u';
		at: #text put: '%T';
		at: #textList put: '%U';
		at: #any put: '%s';
		at: #anyList put:  '%X';
		at: #boolean put: '%b';
		at: #booleanList put: '%V';
		at: #number put: '%n';
		at: #numberList put: '%w';
		at: #template put: '%7';
		at: #loop put: '%G';
		at: #loopList put: '%3';

		at: #object put: '%1';
		at: #objectList put: '%2'.

	^specs at: typeSym ifAbsent: ['%s']! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 3/15/2010 02:37'!
templates

	"answer a Dictionary of externalized local variables"

	| templates parms |
	templates _ Dictionary new.
	parms _ self parameterNames.
	1 to: parms size do: [:i |
		#template = (self typeOfParameterIndex: i) ifTrue: [
			templates at: i put: (parms at: i)]].
	templates keys size > 0 ifFalse: [
		^nil].
	^templates
! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/26/2008 12:50'!
toggleAtomicity
	self isAtomic: isAtomic not! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/14/2010 23:22'!
type
	"currently BYOB supports the following first class types:

    #none		- a puzzle shaped command block
    #any		- a non-typed round reporter block (can be anything)
    #string		- a round reporter block that answers a string
    #number	- a round reporter block that answers a number
    #list			- a round reporter block that answers a number
    #boolean	- a hexagonal reporter block that answers a boolean
    #command	- a round reporter block that answers a procedure (a command block)
    #reporter	- a round reporter block that answers a function (a reporter block)
    #predicate	- a (round?) reporter reporting boolean function

"

	^ type! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 3/9/2010 22:49'!
type: aSymbol

	"currently BYOB supports the following first class types:

    #none		- a puzzle shaped command block
    #any		- a non-typed round reporter block (can be anything)
    #string		- a round reporter block that answers a string
    #number	- a round reporter block that answers a number
    #list			- a round reporter block that answers a number
    #boolean	- a hexagonal reporter block that answers a boolean
    #command	- a round reporter block that answers a procedure (a command block)
    #reporter	- a round reporter block that answers a function (a reporter block)
    #predicate	- a hexagonal reporter block that answers a reporter of a boolean 
    #template	- a sunken variable blob that represents an externalized block variable
"

	type _ aSymbol! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/15/2010 00:07'!
typeOf: parameterName

	^ declarations at: parameterName ifAbsent: [#any]! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/20/2010 16:17'!
typeOfParameterIndex: parmIdx

	^ declarations at: (self parameterNames at: parmIdx ifAbsent: [^ #any])
		ifAbsent: [#any]! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/29/2008 09:39'!
userSpec
	^userSpec! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/14/2010 23:01'!
userSpec: aString

	userSpec _ aString.

"
--- this code used to keep deleted parameters around as block vars that could be
----reused -deprecated now (2010-09-15) -jens

	userSpec ifNotNil: [
		blockVars addAll: (self parameterNamesInSpec: userSpec)].
	userSpec _ aString.
	(self parameterNamesInSpec: userSpec) do: [:var |
		blockVars remove: var ifAbsent: []]
"! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 1/28/2010 00:30'!
varNames

	^blockVars asSortedCollection! !

!CustomBlockDefinition methodsFor: 'accessing' stamp: 'jens 9/30/2008 07:55'!
varNamesMenu
	^self allVarNames asArray! !


!CustomBlockDefinition methodsFor: 'object i/o' stamp: 'jens 1/25/2010 02:27'!
fieldsVersion

	^ 4
! !

!CustomBlockDefinition methodsFor: 'object i/o' stamp: 'JM 10/3/2011 11:18'!
indexForParameterName: aName

	"Returns the index of the supplied parameter name, or nil if not found."
	^ self parameterNames indexOf: aName ifAbsent: [ ^ nil ].

! !

!CustomBlockDefinition methodsFor: 'object i/o' stamp: 'jens 1/25/2010 02:28'!
initFieldsFrom: anObjStream version: classVersion

	self initFieldsNamed: #(
		userSpec
		blockVars
		isAtomic
		isReporter
		isBoolean
		body
		answer
	) from: anObjStream.

	classVersion = 1 ifTrue: [
		^ self deduceType ].

	"fields added in version 2:"
	self initFieldsNamed: #(
		type
		category
		declarations
	) from: anObjStream.

	"fields added in version 3:"
	self initFieldsNamed: #(
		defaults
	) from: anObjStream.

	"fields added in version 4:"
	self initFieldsNamed: #(
		isGlobal
	) from: anObjStream.
! !

!CustomBlockDefinition methodsFor: 'object i/o' stamp: 'jens 1/25/2010 02:27'!
storeFieldsOn: anObjStream

	self storeFieldsNamed: #(
		userSpec
		blockVars
		isAtomic
		isReporter
		isBoolean
		body
		answer
		type
		category
		declarations
		defaults
		isGlobal
	) on: anObjStream.
! !


!CustomBlockDefinition methodsFor: 'private' stamp: 'jens 1/5/2010 00:00'!
deduceType
	"private - set my return type from the BYOB deprecated legacy attributes #isReporter and #isBoolean.
	use this when reading an old block from file"

	isReporter ifFalse: [ ^ type _ #none ].
	isBoolean ifTrue: [ ^ type _ #boolean ].
	^ type _ #any! !

!CustomBlockDefinition methodsFor: 'private' stamp: 'jens 1/27/2010 01:51'!
fixBlockVarReporters


	body ifNotNil: [
		body allMorphs do: [:m|
			((m isKindOf: VariableBlockMorph) | (m isKindOf: SetterBlockMorph) 
				and: [m isSpecialForm]) ifTrue: [
					m receiver: self ]]].
	answer ifNotNil: [ (answer isKindOf: ReporterBlockMorph)
		ifTrue: [answer allMorphs do: [:m|
			((m isKindOf: VariableBlockMorph) | (m isKindOf: SetterBlockMorph) 
				and: [m isSpecialForm]) ifTrue: [
					m receiver: self ]]]].

! !

!CustomBlockDefinition methodsFor: 'private' stamp: 'jens 10/2/2008 11:53'!
getVar: vName
	^0! !

!CustomBlockDefinition methodsFor: 'private' stamp: 'jens 9/30/2008 10:53'!
ownerThatIsA: aClassName
	^nil! !


!CustomBlockDefinition methodsFor: 'initializing' stamp: 'jens 2/26/2010 00:42'!
initialize
	super initialize.
	category _ #none.	"this will be a gray block in the variables palette (jens)"
	type _ #none.
	declarations _ Dictionary new.
	defaults _ Dictionary new.
	isAtomic _ true.
	isReporter _ false.
	isBoolean _ false.
	blockVars _ Set new.
	isGlobal _ true! !


!CustomBlockDefinition methodsFor: 'deprecated' stamp: 'jens 1/5/2010 00:01'!
isBoolean
	"deprecated, kept for BYOB legacy support (jens)"

	^isBoolean! !

!CustomBlockDefinition methodsFor: 'deprecated' stamp: 'jens 1/5/2010 00:01'!
isBoolean: aBoolean
	"deprecated, kept for BYOB legacy support"

	isBoolean _ aBoolean! !

!CustomBlockDefinition methodsFor: 'deprecated' stamp: 'jens 1/5/2010 00:02'!
isReporter
	"deprecated, kept for BYOB legacy support"

	^isReporter! !

!CustomBlockDefinition methodsFor: 'deprecated' stamp: 'jens 1/5/2010 00:02'!
isReporter: aBoolean
	"deprecated, kept for BYOB legacy support"

	isReporter _ aBoolean! !


!CustomBlockDefinition methodsFor: 'migrating' stamp: 'jens 8/2/2010 21:47'!
migrateBlockVars
	"turn my block vars into a VariableDeclarationBlockMorph"

	| dec vars vn spec blob rest |
	blockVars size > 0 ifFalse: [^self].
	dec _ VariableDeclarationBlockMorph new
			color: Color gray;
			isSpecialForm: true;
			minArgs: 1;
			selector: #doDeclareVariables.

	vars _ self varNames.
		spec _ 'script variables' localized.
	vars size timesRepeat: [ spec _ spec, ' %s' ].
	dec commandSpec: spec.
	1 to: vars size do: [:i |
		vn _ vars at: i.
		blob _ VariableBlockMorph new 
				isSpecialForm: true;
				commandSpec: vn  ";
				color: (ScriptableScratchMorph blockColorFor: 'variables')".
		dec replaceArgMorph: (dec argMorphs at: i) by: blob.
		blockVars remove: vn ].

	rest _ body.
	body _ dec.
	rest ifNotNil: [
		body nextBlock: rest ]! !


!CustomBlockDefinition methodsFor: 'enchanting' stamp: 'JM 10/21/2011 14:46'!
lambdaBlocks

	"we need to ensure that lambdas are found not only in the script body but in the anwer block"

	| lambdas |
	lambdas _ OrderedCollection new.
	body ifNotNil: [ lambdas addAll: body lambdaBlocks ].
	lambdas addAll: self answerBlock lambdaBlocks.
	^ lambdas! !

!CustomBlockDefinition methodsFor: 'enchanting' stamp: 'JM 10/20/2011 12:39'!
reports

	"true if this custom block ends with a return statement or has an answer block"
	^ ((type = #none) and: [ body ~= nil and: [ body reports ]]) or: [ (body ~= nil and: [ body reports ]) | answer ~= nil ]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CustomBlockDefinition class
	instanceVariableNames: ''!

!CustomBlockDefinition class methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2010 20:35'!
idFromSpec: aUserSpecOrCommandSpec

	|cmd out|
	cmd _ ScratchServer new parse: aUserSpecOrCommandSpec.
	out _ WriteStream on: String new.
	cmd do: [:each|
		(each asString beginsWith: '%')
			ifTrue: [out nextPutAll: '%s' ]
			ifFalse: [out nextPutAll: each asString].
		out space ].
	^out contents withoutTrailingBlanks! !
