StringMorph subclass: #StringElementMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!StringElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 20:49'!
launchMiniEditor: evt

	| textMorph |

	hasFocus _ true.  "Really only means edit in progress for this morph"
	textMorph _ StringMorphEditor new contentsAsIs: contents.
	textMorph color: self color.
	textMorph beAllFont: self font.
	textMorph bounds: (self bounds expandBy: 0@2).
	self addMorphFront: textMorph.
	evt hand newMouseFocus: textMorph.
	evt hand newKeyboardFocus: textMorph.
	textMorph editor selectFrom: 1 to: textMorph paragraph text string size.
	textMorph mouseDown: evt.
! !


Morph subclass: #SyntaxElementMorph
	instanceVariableNames: 'label name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 23:29'!
aboutToBeGrabbedBy: aHand

	(owner isKindOf: ArgumentElementMorph)
		ifTrue: [owner removeContents. ^self ].
	(owner isKindOf: StepElementMorph)
		ifTrue: [owner removeNext. ^self].
	(owner isKindOf: MessageElementMorph)
		ifTrue: [owner removeCascadedElement: self. ^self].
	^ self


! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 23:36'!
asSmalltalk
	^''! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 11:27'!
borderColorDark
	^color twiceDarker! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 12:02'!
borderColorLight
	^color twiceLighter lighter! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 11:57'!
borderColorVeryDark
	^color twiceDarker darker! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 12:02'!
borderColorVeryLight
	^color twiceLighter twiceLighter lighter! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 21:40'!
borderWidth
	^1
! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 12:58'!
changed
	super changed! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:06'!
contextMenu

	^nil! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 19:45'!
drawOn: aCanvas 

	|r bw |
	bw _ self borderWidth.

	"border"
	"top"
	r _ Rectangle origin: ((self left + bw) @ self top) corner: (self right @ (self top + bw)).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	"left"
	r _ Rectangle origin: (self topLeft) corner: (self left + bw) @ (self bottom - bw).
	aCanvas fillRectangle: r color: self borderColorLight.

	"right"
	r _ Rectangle origin: ((self right - bw) @ (self top + bw)) corner: self bottomRight.
	aCanvas fillRectangle: r color: self borderColorDark.

	"bottom"
	r _ Rectangle origin: (self left @ (self bottom - bw)) corner: (self right - bw) @ self bottom.
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	"body"
"	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self bottomRight - bw)) color: color"

	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self right - bw) @ (self center y - bw)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y - bw) corner: (self right - bw) @ (self center y)) color: color lighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw @ (self center y)) corner: (self bottomRight - bw)) color: color

! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/2/2009 23:43'!
duplicate
	World activeHand addMorph: super fullCopy! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/13/2009 12:41'!
evaluate
	^Compiler evaluate: self asSmalltalk! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 22:07'!
fit
	self extent: label extent + (self borderWidth * 2).
	self width: (self width + (self labelFont widthOf: $ )).
	label position: bounds center - (label extent // 2).
	(owner respondsTo: #fit)
		ifTrue: [owner fit]
! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 22:56'!
handlesMouseDown: evt
	"Return true if this morph wants to receive mouseDown events (i.e., mouseDown:, mouseMove:, mouseUp:). The default response is false; subclasses that implement mouse messages should override this to return true." 

	^ true! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 12:36'!
initialize
	super initialize.
	color _ Color red! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:18'!
invokeContextMenu
	|m choice|
	m _ self contextMenu.
	m ifNotNil: [
		choice _ m startUp.
		choice ifNotNil: [self perform: choice] ]! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 00:43'!
isRenameable
	| editor |
	editor _ (self ownerThatIsA: ElementsMethodEditorMorph).
	^editor isNil
	! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 20:46'!
label
	^name
	"^label contents"! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 23:47'!
label: aString

	name _ aString.
	label ifNil: [
		label _ StringMorph contents: '' font: self labelFont.
		label color: self labelColor.
		self addMorphFront: label].
	label contents: (self wordsFrom: name).
	self fit
! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 12:36'!
labelColor
	^Color white! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 21:39'!
labelFont
	^StrikeFont fontName: 'Verdana' size: 10! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:02'!
mouseDown: evt
	"Handle a mouse down event."

	evt rightButtonPressed
		ifTrue: [ ^self invokeContextMenu].
	self startDrag: evt
! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:29'!
name
	^name! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:50'!
representsNil
	^false! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:04'!
rootForGrabOf: aMorph
	"Allow myself to be extracted."

	(owner notNil and: [owner isPartsBin])
		ifTrue: [^ super rootForGrabOf: aMorph]
		ifFalse: [^ self].
! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:40'!
showGeneratedSmalltalk
	"StringHolder new contents: self asSmalltalk; openLabel: self class printString"	
	self inform: self asSmalltalk! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/13/2009 12:53'!
showResult
	self inform: self evaluate printString! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/5/2009 00:16'!
throwAway
	self aboutToBeGrabbedBy: nil; delete! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 22:13'!
wordsFrom: camelCase
	^self class wordsFrom: camelCase! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SyntaxElementMorph class
	instanceVariableNames: ''!

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 20:38'!
classNameFrom: aUserString
	"answer a camel-cased uppercased String"

	^(aUserString allWordsCapitalized reject: [:c|
		c = $ ]) capitalized! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/4/2009 02:33'!
fromString: aString

	|strg method compiler|
	strg _ aString, '.^self'.
	compiler _ Compiler new.
	compiler from: (ReadStream on: strg)
		class: nil class
		context: nil
		notifying: nil.

	method _ compiler translate: (ReadStream on: strg) noPattern: true ifFail: nil.
	World activeHand attachMorph: method asElementFromText

	! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 01:19'!
isDecompilable: selector class: class

	|  original compiled text node|
	original _ class methodDict at: selector.
	text _ ((class decompilerClass new)
		decompile: selector in: class method: original) printString.
	node _ Compiler new 
		compile: text 
		in: class 
		notifying: nil 
		ifFail: [self inform: 'compilation failed'].
	compiled _ node generate: #(0 0 0 0).
	original = compiled
		ifFalse: [Transcript nextPut: $-].
	^original = compiled
		
		! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 20:42'!
objectNameFrom: aUserString
	"answer a camel-cased String beginning with a lowercase character"

	|ans|
	ans _ self classNameFrom: aUserString.
	ans at: 1 put: (ans at: 1) asLowercase.
	^ans! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 20:55'!
selectorFrom: aUserString
	"answer a camel-cased Symbol beginning with a lowercase character"

	|ans ws char|
	ans _ self classNameFrom: aUserString.
	ans at: 1 put: (ans at: 1) asLowercase.
	ws _ WriteStream on: String new.
	1 to: ans size do: [:i|
		char _ ans at: i.
		(char isUppercase and: [ (ans at: i - 1) = ($:)])
			ifTrue: [ws nextPut: char asLowercase]
			ifFalse: [ws nextPut: char]].
	^ws contents asSymbol! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 1/30/2009 00:50'!
test
	1 even ifTrue:[] ifFalse:[^'yes']! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 01:21'!
testAllMethods
	"SyntaxElementMorph testAllMethods"

	| eachClass methods original compiled element|
	Smalltalk classNames do: [: className |
		eachClass _ Smalltalk classNamed: className.
		methods _ eachClass methodDict.
		methods keysDo: [ :eachSelector|
			(self isDecompilable: eachSelector class: eachClass)
				ifTrue: [
					original _ methods at: eachSelector.
					element _ ((eachClass decompilerClass new)
						decompile: eachSelector 
						in: eachClass 
						method: original) asSyntaxElement.
					compiled _ element asCompiledMethodForClass: eachClass.
					original = compiled
						ifTrue: [Transcript show:'.']
						ifFalse: [Transcript cr; 
							show: className asString, ' -> ', 
								eachSelector printString; cr]]]]
		
		! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 00:31'!
testAllOriginalMethods

	| eachClass methods original compiled text node|
	Smalltalk classNames do: [: className |
		eachClass _ Smalltalk classNamed: className.
		methods _ eachClass methodDict.
		methods keysDo: [ :eachSelector|
			original _ methods at: eachSelector.
			text _ ((eachClass decompilerClass new)
				decompile: eachSelector in: eachClass method: original) printString.
			node _ Compiler new 
				compile: text 
				in: eachClass 
				notifying: nil 
				ifFail: [self inform: 'compilation failed'].
			compiled _ node generate: #(0 0 0 0).
			original = compiled
				ifTrue: [Transcript show:'.']
				ifFalse: [Transcript cr; 
					show: className asString, ' -> ', 
						eachSelector printString; cr]]]
		
		! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 23:37'!
wordsFrom: camelCase
	| ws cap |
	
	cap _ camelCase first isUppercase.

	(camelCase = 'ifTrue')
		ifTrue: [^'yes'].
	(camelCase = 'ifFalse')
		ifTrue: [^'no '].
	(camelCase = '_')
		ifTrue: [^':='].

	ws _ WriteStream on: String new.

	camelCase do: [:c|
		c isUppercase 
			ifTrue: [ 
			ws nextPut: $ ; 
			nextPut: (cap ifTrue: [c] ifFalse: [c asLowercase ])]
			ifFalse: [ 
				ws nextPut: c.
				(c = ($:)) ifTrue: [ws nextPut: $ ]]].
	^ws contents
! !


SyntaxElementMorph subclass: #ArgumentElementMorph
	instanceVariableNames: 'contents oldColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/6/2009 13:40'!
acceptDroppingMorph: aMorph event: evt

	self contentsForced: aMorph! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/5/2009 00:50'!
asSmalltalk

	contents ifNil: [^'nil '].
	((#(	BlockElementMorph
		LiteralElementMorph
		ObjectElementMorph
	) includes: contents class printString asSymbol)
		or: [owner isKindOf: StepElementMorph])
		ifTrue: [^contents asSmalltalk].

	(contents isKindOf: MessageElementMorph) ifTrue: [
		contents isUnary ifTrue: [^contents asSmalltalk].

		contents isBinary ifTrue: [
			owner isKeywords ifTrue: [ ^contents asSmalltalk]]

	].

	^'(', contents asSmalltalk, ')'! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 13:38'!
contents
	^contents! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:51'!
contents: anElement
	contents ifNotNil: [contents delete].
	anElement representsNil ifFalse: [
		contents _ anElement.
		self addMorphFront: contents ].
	self fit.
	self unHilite
! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 21:09'!
contentsForced: anElement
	contents ifNotNil: [contents delete].
	contents _ anElement.
	contents position: self position.
	self addMorphFront: contents.
	self fit.
	self unHilite
! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 21:13'!
drawOn: aCanvas 

	|r bw|

	bw _ self borderWidth.

	"border"
	"top"
	r _ Rectangle origin: ((self left + bw) @ self top) corner: (self right @ (self top + bw)).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	"left"
	r _ Rectangle origin: (self topLeft) corner: (self left + bw) @ (self bottom - bw).
	aCanvas fillRectangle: r color: self borderColorDark.

	"right"
	r _ Rectangle origin: ((self right - bw) @ (self top + bw)) corner: self bottomRight.
	aCanvas fillRectangle: r color: self borderColorLight.

	"bottom"
	r _ Rectangle origin: (self left @ (self bottom - bw)) corner: (self right - bw) @ self bottom.
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	"body"
	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self bottomRight - bw)) color: color
! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 22:49'!
fit
	| h |
	contents isNil
		ifTrue: [
			h _ MessageElementMorph labelFont height.
			self extent: h @ h]
		ifFalse: [
			self extent: contents extent " + (self borderWidth * 2)".
			"(owner isKindOf: StepElementMorph)
				ifTrue: [self extent: self extent + (self borderWidth * 2)]."
			contents position: bounds center - (contents extent // 2) ].
	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:06'!
handlesMouseOverDragging: evt
	"Return true if I want to receive mouseEnterDragging: and mouseLeaveDragging: when the hand drags something over me (button up or button down), or when the mouse button is down but there is no mouseDown recipient. The default response is false; subclasses that implement mouse mouseEnterDragging messages should override this to return true."

	"NOTE:  If the hand state matters in these cases, it may be tested by constructs such as
		event anyButtonPressed
		event hand hasSubmorphs"

	^ true
! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:46'!
hilite
	oldColor _ color.
	self color: Color white! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:47'!
initialize
	super initialize.
	color _ Color veryVeryLightGray.
	self fit! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 01:00'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event. The mouse just entered my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	| m |
	evt hand hasSubmorphs ifFalse: [^self].
	m _ evt hand submorphs first.
	(self wantsDroppedMorph: m event: evt)
		ifTrue: [
			self extent: m extent  + (self borderWidth * 2).
			self hilite ].
	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:48'!
mouseLeaveDragging: evt
	"Handle a mouseLeaveLaden event. The mouse just left my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	self fit.
	self unHilite! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2009 20:53'!
removeContents
	contents ifNotNil: [ contents _ nil ].
	self fit.
! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:37'!
rootForGrabOf: aMorph
	"Answer the root of the morph structure to be picked up when the given morph is grabbed."

	owner ifNotNil: [^owner rootForGrabOf: aMorph].
	^nil

"	(self isSticky and: [self isPartsDonor not])
		ifTrue: [^ nil]
		ifFalse: [
			(owner isNil or: [owner isWorldOrHandMorph])
				ifTrue: [^ self]
				ifFalse: [
					owner allowSubmorphExtraction
						ifTrue: [^ self]
						ifFalse: [^ owner rootForGrabOf: aMorph]]].
"! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:47'!
unHilite

	oldColor ifNotNil: [
		self color: oldColor]! !

!ArgumentElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:51'!
wantsDroppedMorph: aMorph event: evt

	^contents isNil 
		& (self ownerThatIsA: ElementPaletteMorph) isNil
		& ((aMorph isKindOf: ObjectElementMorph) 
		| (aMorph isKindOf: LiteralElementMorph) 
		| (aMorph isKindOf: BlockElementMorph) 
		| (aMorph isKindOf: MessageElementMorph))! !


SyntaxElementMorph subclass: #BlockElementMorph
	instanceVariableNames: 'palette steps '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/19/2009 23:56'!
addStep: aStepElement
	steps contents isNil 
		ifTrue: [steps contents: aStepElement]
		ifFalse: [steps contents addToLast: aStepElement]! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2009 23:35'!
addVarNames: aCollection
	palette addVarNames: aCollection
! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:00'!
addVariable
	|ans|

	ans _ FillInTheBlank request: 'add variable:'.
	(ans size > 0) ifTrue: [self addVarNames: (Array with: (SyntaxElementMorph objectNameFrom: ans))]! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/19/2009 18:34'!
addVariableNamed: aSymbol
	palette addVariableNamed: aSymbol! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 00:04'!
addVariables
	|ans|

	ans _ FillInTheBlank request: 'add variables:'.
	(ans size > 0) ifTrue: [self addVarNames: (ans findTokens: ' ')]! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 07:32'!
allVariableNames
	^self variableNames! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 22:33'!
asSmalltalk
	| ws vn|
	ws _ WriteStream on: String new.
	ws nextPut: $[.
	(vn _ self variableNames) isEmpty ifFalse: [
		vn do: [:n|
			ws nextPut: $:.
			ws nextPutString: n, ' ' ].
		ws nextPutString: '| '].
	ws nextPutString: steps asSmalltalk, ']'.
	^ws contents! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/27/2009 23:01'!
contextMenu
	|m|
	m _ CustomMenu new.
"	m add: 'duplicate' action: #duplicate. "
	m add: 'delete' action: #throwAway.
	m add: 'add variable...' action: #addVariable.
	m addLine.
	m add: 'show code...' action: #showGeneratedSmalltalk.
	m add: 'show result...' action: #showResult.
	m add: 'evaluate' action: #evaluate.
	^m! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/4/2009 02:41'!
evaluate
	^Compiler evaluate: self asSmalltalk, ' value'! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 00:17'!
fit
	| bw bw2 cw handle x y|
	bw _ self borderWidth.
	bw2 _ bw * 2.
	cw _ self labelFont widthOf: $ .
	handle _ cw * 2.

	palette position: (self left + handle) @ (self top).
	(palette height = 0)
		ifTrue: [y _ self top + (bw * 3)]
		ifFalse: [y _ palette bottom].
	

	steps position: (self left + bw2 + handle) @ y.

	x _ (steps right + bw2) max: palette right.

	self width: x - self left.
	(palette height = 0)
		ifTrue: [ self height: steps height + (self borderWidth * 5) ]
		ifFalse: [self height: steps height + palette height + (bw2) ].

	self refreshVarColors.

	(owner respondsTo: #fit)
		ifTrue: [owner fit]
! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 21:19'!
initialize
	super initialize.
	color _ Color paleBlue darker.
	palette _ PaletteElementMorph new.
	self addMorph: palette.
	steps _ StepHolderElementMorph new.
	steps color: color slightlyDarker.
	self addMorph: steps.
	self fit.! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 23:41'!
refreshVarColors

	self allMorphsDo: [:m|
		((m isMemberOf: ObjectElementMorph) and: [
			self allVariableNames includes: m name]) ifTrue: [
				m color: self varColor ]]! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 00:18'!
rootForGrabOf: aMorph
	"Allow myself to be extracted."

	(self ownerThatIsA: ElementPaletteMorph) ifNotNil: [
		(self ownerThatIsA: MessageElementMorph)
			ifNotNil: [^owner rootForGrabOf: owner ]].
	^super rootForGrabOf: aMorph! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/4/2009 02:24'!
steps
	^steps contents! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2009 23:58'!
varColor
	^palette varColor! !

!BlockElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 00:05'!
variableNames
	^palette variableNames! !


SyntaxElementMorph subclass: #LiteralElementMorph
	instanceVariableNames: 'textBox contents '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!LiteralElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 23:54'!
asSmalltalk
	^textBox contents! !

!LiteralElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2009 22:15'!
contents: aLiteral
	(aLiteral isMemberOf: Array)
		ifTrue: [ textBox label: '#', aLiteral printString ]
		ifFalse: [ textBox label: aLiteral printString ]! !

!LiteralElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/27/2009 23:01'!
contextMenu
	|m|
	m _ CustomMenu new.
"	m add: 'duplicate' action: #duplicate. "
	m add: 'delete' action: #throwAway.
	m addLine.
	m add: 'show code...' action: #showGeneratedSmalltalk.

	^m! !

!LiteralElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 21:54'!
fit

	| bw cw handle |
	bw _ self borderWidth.
	cw _ self labelFont widthOf: $ .
	handle _ cw * 2.

	self extent: textBox extent + (bw * 4).
	self width: self width + handle.

	textBox position: (self left + handle + bw) @ (self center - (textBox extent // 2)) y.

	(owner respondsTo: #fit)
		ifTrue: [owner fit]
! !

!LiteralElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 22:04'!
initialize
	super initialize.
	color _ Color blue darker.
	textBox _ TextBoxElementMorph new label: ''.
	self addMorph: textBox.
	self fit! !


SyntaxElementMorph subclass: #MessageElementMorph
	instanceVariableNames: 'receiver selector arguments labels cascade '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 21:27'!
acceptDroppingMorph: aMorph event: evt

	self addToCascade: aMorph! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:41'!
addLabel
	label _ StringMorph contents: '' font: self labelFont.
	label color: self labelColor.
	self addMorphFront: label.
! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:29'!
addReceiver
	receiver _ ArgumentElementMorph new.
	self addMorphFront: receiver.! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 18:52'!
addToCascade: aMessageElement
	cascade add: aMessageElement.
	self addMorph: aMessageElement.
	aMessageElement embedAsCascade! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 00:26'!
argumentCount
	^arguments size! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2009 22:42'!
arguments: anArray

	1 to: anArray size do: [:i|
		(arguments size < i) ifFalse: [
			(arguments at: i) contents: (anArray at: i ) ]]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 01:00'!
asSmalltalk
	| ws |
	receiver isHidden ifTrue: [^self keywordsAndArgs ].
	cascade isEmpty not ifTrue: [ ^self cascadeCode ].

	ws _ WriteStream on: String new.
	^ws
		nextPutString: receiver asSmalltalk, ' ';
		nextPutString: self keywordsAndArgs;
		contents! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 23:49'!
assign
	self selector: #_ arguments: { ObjectElementMorph new }.
	(arguments at: 1) contents delete. 
	(arguments at: 1) removeContents! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:52'!
beBinary
	self binarySelector: selector! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:53'!
binarySelector: aString

	| lb arg |

	selector _ aString.
	label ifNotNil: [label delete. label _ nil].
	labels do: [:each| each delete ].
	arguments do: [:each| each delete ].
	labels _ OrderedCollection new.
	arguments _ OrderedCollection new.

	lb _ ((StringMorph contents: aString font: self labelFont) color: self labelColor).
	labels add: lb.
	self addMorph: lb.
	arg _ ArgumentElementMorph new.
	arguments add: arg.
	self addMorph: arg.
	self fit! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 00:42'!
buildLabelsAndArgs

	| tokens lb arg |
	label ifNotNil: [label delete. label _ nil].
	labels do: [:each| each delete ].
	arguments do: [:each| each delete ].
	labels _ OrderedCollection new.
	arguments _ OrderedCollection new.

	((selector includes: $:) not | (selector = ':=')) ifTrue: [
		self label: (self wordsFrom: selector).
		^self ].

	tokens _ selector findTokens: ':'.
	tokens do: [:each| 
		lb _ ((StringMorph contents: (self wordsFrom: each) font: self labelFont) color: self labelColor).
		labels add: lb.
		self addMorph: lb.
		arg _ ArgumentElementMorph new.
		arguments add: arg.
		self addMorph: arg].
		! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 01:10'!
cascadeCode
	| ws |
	ws _ WriteStream on: String new.
	ws nextPutString: receiver asSmalltalk.
	cascade do: [:msg|
		ws cr;
			nextPutString: msg asSmalltalk, ' ';
			nextPut:$; ].
	^ws
		nextPutString: self keywordsAndArgs;
		cr; 
		contents! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/27/2009 23:02'!
contextMenu
	|m|
	m _ CustomMenu new.
"	m add: 'duplicate' action: #duplicate. "
	m add: 'delete' action: #throwAway.
	self isRenameable
		ifTrue: [
			m add: 'rename...' action: #editSelector.
			arguments isEmpty ifTrue: [
				m add: 'add argument' action: #beBinary ].
			m addLine ]
		ifFalse: [m addLine ].
	m add: 'show code...' action: #showGeneratedSmalltalk.
	m add: 'show result...' action: #showResult.
	m add: 'evaluate' action: #evaluate.
	^m! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:21'!
editSelector
	|ans|

	ans _ FillInTheBlank request: 'selector:' initialAnswer: selector.
	(ans size > 0) ifTrue: [self selector: ans]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 18:51'!
embedAsCascade
	receiver isHidden: true.
	self fit! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 23:30'!
extractFromCascade
	receiver isHidden: false.
	self fit! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2009 21:41'!
fit

	receiver isHidden ifTrue: [^self fitForCascade ].
	cascade isEmpty not ifTrue: [ ^self fitCascaded ].
	self isStacked
	ifTrue: [self fitStacked]
	ifFalse: [self fitInLine]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/21/2009 22:08'!
fitCascaded
	| cw bw bw2 x y arg lb maxHeight maxRight labelTop labelBottom cntr |
	cw _ self labelFont widthOf: $ .
	bw _ self borderWidth.
	bw2 _ bw * 2.

	x _ receiver right + bw2.
	maxRight _ x.
	y _ self top + bw2.

	cascade do: [:eachElement |
		eachElement position: x @ y.
		maxRight _ maxRight max: eachElement right.
		y _ eachElement bottom ].
	x _ x + (bw * 3).
	labelTop _ y + bw.

	labels isEmpty 
		ifTrue: [
			label position: x @ labelTop.
			maxRight _ maxRight max: label right.
			maxHeight _ label height.
			labelBottom _ label bottom ]
		ifFalse: [
			maxHeight _ labels anyOne height.
			1 to: labels size do: [:i |
				arg _ arguments at: i.
				lb _ labels at: i.
				maxHeight _ maxHeight max: (arg height).

				lb position: x @ labelTop.
				x _ x + lb width + cw.
				arg position: x @ labelTop.
				x _ x + arg width + cw ].
			x _ x - cw.
			maxRight _ maxRight max: x.

			cntr _ labelTop + (maxHeight // 2).

			arguments do: [:each|
				each position: (each position x @ (cntr - (each height // 2))) ].
			labels do: [:each|
				each position: (each position x @ (cntr - (each height // 2))) ]].

	labelBottom _ labelTop + maxHeight.
	labelBottom _ labelBottom max: receiver bottom.

	self extent: ((maxRight - self left) @ (labelBottom - self top)) + bw2.



	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 20:51'!
fitForCascade

	| cw bw bw2 x arg lb maxHeight |
	cw _ self labelFont widthOf: $ .
	bw _ self borderWidth.
	bw2 _ bw * 2.

	x _ self left + bw2.

	labels isEmpty 
		ifTrue: [^super fit]
		ifFalse: [
			maxHeight _ labels anyOne height.
			1 to: labels size do: [:i |
				arg _ arguments at: i.
				lb _ labels at: i.
				maxHeight _ maxHeight max: (arg height).

				lb position: x @ (lb position y).
				x _ x + lb width + cw.
				arg position: x @ (arg position y).
				x _ x + arg width + cw ].
			self extent: (x - self position x - cw - bw2) @ maxHeight + (bw2 * 2).
			receiver position: (receiver position x @ (bounds center y - (receiver height // 2))).
			arguments do: [:each|
				each position: (each position x @ (bounds center y - (each height // 2))) ].
			labels do: [:each|
				each position: (each position x @ (bounds center y - (each height // 2))) ].
].

	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 01:06'!
fitInLine

	| h w cw bw bw2 x arg lb maxHeight |
	cw _ self labelFont widthOf: $ .
	bw _ self borderWidth.
	bw2 _ bw * 2.

	receiver position: (self left + bw2) @ (self top + bw2).
	x _ receiver right + cw.

	labels isEmpty 
		ifTrue: [
			h _ receiver height + (bw2 * 2).
			w _ receiver width + (label width) + (cw * 1.5) + (bw2 * 2).

			self width: w.
			self height: h.

			label position: x @ (bounds center y - (label height // 2)).

			self isLabelFirst ifTrue: [
				label position: (receiver position x) @ (label position y).
				receiver position: (label right + cw) @ (receiver position y) ]]
		ifFalse: [
			maxHeight _ receiver height.
			1 to: labels size do: [:i |
				arg _ arguments at: i.
				lb _ labels at: i.
				maxHeight _ maxHeight max: (arg height).

				lb position: x @ (lb position y).
				x _ x + lb width + cw.
				arg position: x @ (arg position y).
				x _ x + arg width + cw ].
			self extent: (x - self position x - cw - bw2) @ maxHeight + (bw2 * 2).
			receiver position: (receiver position x @ (bounds center y - (receiver height // 2))).
			arguments do: [:each|
				each position: (each position x @ (bounds center y - (each height // 2))) ].
			labels do: [:each|
				each position: (each position x @ (bounds center y - (each height // 2))) ].
].

	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 19:08'!
fitStacked

	| h w cw bw bw2 x y arg lb maxRight |
	cw _ self labelFont widthOf: $ .
	bw _ self borderWidth.
	bw2 _ bw * 2.

	receiver position: (self left + bw2) @ (self top + bw2).
	x _ receiver right + cw.
	y _ receiver bottom + bw.

	labels isEmpty 
		ifTrue: [
			h _ receiver height + (bw2 * 2).
			w _ receiver width + (label width) + (cw * 1.5) + (bw2 * 2).

			self width: w.
			self height: h.

			label position: x @ (bounds center y - (label height // 2)) ]
		ifFalse: [
			maxRight _ receiver right.
			1 to: labels size do: [:i |
				arg _ arguments at: i.
				lb _ labels at: i.

				lb position: receiver left + cw @ (y + ((arg height - lb height) // 2)).
				arg position: (lb right + cw) @ y.

				y _ y + arg height + bw.

				maxRight _ maxRight max: (arg right) ].

			self extent: ((maxRight - self left) + bw2) @ ((y - self top) + bw)].

	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 23:32'!
fullCopy
	|copy|
	copy _ self class new selector: selector.
	(#ifTrue:ifFalse: = selector) 
		ifTrue: [copy yesNo ].
	(#_ = selector) 
		ifTrue: [copy assign ].
	copy position: self position.
	(copy argumentCount < self argumentCount)
		ifTrue: [copy beBinary].
	^copy! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 18:39'!
hasCascade
	^cascade isEmpty not! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 18:14'!
initialize
	super initialize.
	labels _ OrderedCollection new.
	arguments _ OrderedCollection new.
	cascade _ OrderedCollection new.
	color _ Color orange darker.
	self addLabel.
	self addReceiver.
	self fit.! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 18:24'!
isBinary

	^(arguments size = 1) and: [
		selector asString last ~= ($:)]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/5/2009 00:51'!
isKeywords
	^arguments size > 0 & self isBinary not! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 01:58'!
isLabelFirst
	|firstWord disabled|
	disabled _ true. "change this to experiment with swapped unaries"
	disabled ifTrue: [^false].

	selector ifNil: [^false].
	firstWord _ (self label findTokens: ' ') first. 
		(#('is' 'as' 'has'	'wants') includes: firstWord)
			ifTrue: [ ^false].

	^arguments isEmpty & cascade isEmpty & receiver isHidden not! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 23:24'!
isStacked
	^((#(
		'isNil:'
		'ifNil:'
		'ifNotNil:'
		'ifTrue:'
		'ifFalse:'
		'ifTrue:ifFalse:'
		'ifFalse:ifTrue:'
		'select:'
		'detect:'
		'detect:ifNone:'
		'collect:'
		'reject:'
		'select:'
		'do:'
		'to:do:'
		'whileTrue:'
		'or:'
		'and:'
	)
	includes: selector) or: [
	(arguments select: [:arg | 
		arg contents isKindOf: BlockElementMorph])
			size > 0 ]) or: [ selector notNil and: [
				(selector findTokens: ':') size > 3] ]
! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 17:52'!
isUnary

	^arguments isEmpty! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 02:34'!
keywordsAndArgs
	| kw ws |
	kw _ selector keywords.
	(selector = ':=') ifTrue: [kw _ #('_')].
	ws _ WriteStream on: String new.
	1 to: kw size do: [:i|
		ws nextPutString: (kw at: i).
		(arguments size < i) ifFalse: [
			ws nextPutString: ' ', (arguments at: i) asSmalltalk, ' ' ]].
	^ws contents! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:06'!
labelFont
	^self class labelFont! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 15:26'!
receiver
	^receiver contents! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/20/2009 00:09'!
receiver: anElement
	receiver contents: anElement! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 23:30'!
removeCascadedElement: element

	cascade remove: element ifAbsent: [].
	self fit.
	element extractFromCascade.
	^self! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 22:53'!
rootForGrabOf: aMorph
	"Answer the root of the morph structure to be picked up when the given morph is grabbed."

	aMorph == self ifTrue: [^super rootForGrabOf: aMorph ].
	(aMorph isKindOf: self class) ifTrue: [^self].
	^super rootForGrabOf: aMorph
! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 23:38'!
selector: aString

	selector _ aString.
	self buildLabelsAndArgs.
	self fit! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 22:57'!
selector: aString arguments: anArray

	"for decompilation purposes only. Caution: this method assumes that the number of arguments matches the
	number of parameters required by the selector."

	| tokens lb arg |

	selector _ aString.
	label ifNotNil: [label delete. label _ nil].
	labels do: [:each| each delete ].
	arguments do: [:each| each delete ].
	labels _ OrderedCollection new.
	arguments _ OrderedCollection new.

	anArray isEmpty ifTrue: [
		self label: (self wordsFrom: selector).
		^self fit ].

	tokens _ selector findTokens: ':'.
	1 to: tokens size do: [:i |
		lb _ ((StringMorph 
				contents: (self wordsFrom: (tokens at: i)) 
				font: self labelFont) 
				color: self labelColor).
		labels add: lb.
		self addMorph: lb.
		arg _ ArgumentElementMorph new.
		arguments add: arg.
		self addMorph: arg.
		arg contents: (anArray at: i)].

	self fit! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 23:34'!
wantsDroppedMorph: aMorph event: evt

	(owner isKindOf: self class) ifTrue: [owner hasCascade ifTrue: [^false]].
	^(aMorph isKindOf: self class) and: [ (aMorph hasCascade not) & (aMorph receiver isNil) ]! !

!MessageElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 23:31'!
yesNo
	^self selector: #ifTrue:ifFalse: arguments: { BlockElementMorph new. BlockElementMorph new }.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MessageElementMorph class
	instanceVariableNames: ''!

!MessageElementMorph class methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:06'!
labelFont
	^StrikeFont fontName: 'Verdana' size: 10! !


BlockElementMorph subclass: #MethodElementMorph
	instanceVariableNames: 'header '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 01:03'!
asCompiledMethodForClass: aClass
	| mn1 cm st |
	st _ self asSmalltalk.
	mn1 _ Compiler new compile: st in: aClass notifying: nil ifFail: [self inform: 'compiling failed'].
	cm _ mn1 generate: #(0 0 0 0).
	^cm ! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:37'!
asSmalltalk
	| ws vn|
	ws _ WriteStream on: String new.
	ws nextPutString: header asSmalltalk; cr; cr.
	(vn _ self localVariableNames) isEmpty ifFalse: [
		ws nextPutString: '| '.
		vn do: [:n|
			ws nextPutString: n, ' ' ].
		ws
			nextPutString: '|';
			nextPut: Character cr].
	ws nextPutString: steps asSmalltalk.
	^ws contents! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/5/2009 00:35'!
contextMenu
	|m|
	m _ super contextMenu.
	self isRenameable ifTrue: [
		m addLine.
		m add: 'rename...' action: #editSelector ].
	^m! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/16/2009 00:24'!
editSelector
	header editSelector! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 10:58'!
fit
	| bw bw2 cw handle x y editor|

	header ifNil: [^self ].
	bw _ self borderWidth.
	bw2 _ bw * 2.
	cw _ self labelFont widthOf: $ .
	handle _ cw.

	header position: (self left + bw + handle) @ (self top).

	palette position: (self left + handle) @ (header bottom).
	(palette height = 0)
		ifTrue: [y _ header bottom + (bw * 3)]
		ifFalse: [y _ palette bottom].
	

	steps position: (self left + bw2 + handle) @ y.

	x _ ((steps right + bw2) max: palette right) max: header right.

	self width: x - self left.
	(palette height = 0)
		ifTrue: [ self height: steps height + header height + (bw * 6) ]
		ifFalse: [self height: steps height + palette height + header height + (bw2) ].

	self refreshVarColors.

	(owner respondsTo: #fit)
		ifTrue: [^owner fit].

	editor _ (self ownerThatIsA: ElementsMethodEditorMorph).
	editor ifNotNil: [editor methodModified ]! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:37'!
fitMethod
	|editor|
	(self findA: StepHolderElementMorph) fitMethod.
	editor _ (self ownerThatIsA: ElementsMethodEditorMorph).
	editor ifNotNil: [editor methodModified ]! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 00:48'!
initialize
	super initialize.
	color _ Color paleTan.
	steps color: color slightlyDarker.
	header _ MessageHeaderElementMorph new.
	self addMorph: header.
	self fit.! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 14:22'!
isRenameable
	^true! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:37'!
localVariableNames
	^super variableNames! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:58'!
rootForGrabOf: aMorph
	"Allow myself to be extracted."

	(self ownerThatIsA: ElementsMethodEditorMorph) notNil
		ifTrue: [^nil].
	^super rootForGrabOf: aMorph! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 22:33'!
selector
	^header selector asSymbol! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 00:31'!
selector: aSymbol arguments: aCollection
	header selector: aSymbol arguments: aCollection! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/24/2009 23:03'!
stackBottom
	steps contents isNil
		ifTrue: [^self bottom ]
		ifFalse: [^steps contents stack last bottom ]
	! !

!MethodElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 00:06'!
variableNames
	^super variableNames, header variableNames! !


SyntaxElementMorph subclass: #ObjectElementMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 23:44'!
asSmalltalk 

	^name ifNil: ['undefined']! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/27/2009 23:02'!
contextMenu
	|m|
	m _ CustomMenu new.
"	m add: 'duplicate' action: #duplicate. "
	m add: 'delete' action: #throwAway.
	(owner class == PaletteElementMorph)
		ifTrue: [m add: 'remove' action: #removeFromPalette ]
		ifFalse: [
		 	self isRenameable ifTrue: [
				m add: 'rename...' action: #editLabel ]].
	m addLine.
	m add: 'show code...' action: #showGeneratedSmalltalk.

	^m! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:15'!
editLabel
	|ans|

	ans _ FillInTheBlank request: 'rename:' initialAnswer: label contents.
	(ans size > 0) ifTrue: [self label: ans]! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/9/2009 11:14'!
initialize
	super initialize.
	color _ Color blue darker.
! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 14:26'!
isRenameable
	| editor method |
	editor _ (self ownerThatIsA: ElementsMethodEditorMorph).
	editor isNil ifTrue: [^true].
	method _ (self ownerThatIsA: MethodElementMorph).
	method ifNotNil: [
		^(self ownerThatIsA: StepHolderElementMorph) isNil].
	^false
! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 00:13'!
label
	^label contents! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/2/2009 22:28'!
label: aString

	super label: aString.

	(owner isKindOf: PaletteElementMorph)
		ifTrue: [^self color: owner ownerColor twiceDarker ].

	(#('self' 'super' 'nil' 'true' 'false' 'thisContext') includes: aString)
		ifTrue: [^self color: Color red darker].

	aString first isUppercase
		ifTrue: [
			(Smalltalk classNames includes: aString asSymbol)
				ifTrue: [^self color: Color magenta darker darker].
			(Smalltalk keys includes: aString asSymbol)
				ifTrue: [^self color: Color magenta twiceDarker darker].

			^self color: Color blue twiceDarker ].

	self color: Color blue darker..

! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 15:14'!
labelFont
	^StrikeFont fontName: 'Verdana' size: 10! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 00:17'!
removeFromPalette
	owner removeVariable: self! !

!ObjectElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:50'!
representsNil
	^name = 'nil'! !


SyntaxElementMorph subclass: #PaletteElementMorph
	instanceVariableNames: 'variables '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
addVarNames: aCollectionOfSymbols
	aCollectionOfSymbols do: [:each|
		self addVariableNamed: each asSymbol ]! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
addVariableNamed: aSymbol

	| v |
	v _ ObjectElementMorph new label: aSymbol asString.
	v color: self varColor.
	variables at: aSymbol put: v.
	self addMorph: v.
	self fit! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
drawOn: aCanvas 

^self! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
fit
	| x y bw2|
	bw2 _ self borderWidth * 2.

	variables isEmpty ifTrue: [
		self extent: 0@0.
		(owner respondsTo: #fit)
			ifTrue: [^owner fit]
			ifFalse: [^self]].

	self height: variables anyOne height + (bw2 * 2).
	x _ self left + bw2.
	y _ (self center - (variables anyOne extent // 2)) y.
	variables keys asSortedCollection do: [:vn |
		(variables at: vn) position: x @ y.
		x _ (variables at: vn) right + bw2.
		].
	self width: (x - self position x).

	(owner respondsTo: #fit)
		ifTrue: [^owner fit]! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
initialize
	super initialize.
	variables _ Dictionary new.
	color _ Color transparent.
	self fit! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
isPartsBin

	^ true
! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
ownerColor
	owner ifNotNil: [^owner color].
	^Color gray! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:27'!
removeVariable: element

	element delete.
	variables removeKey: element name asSymbol.
	self fit! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 21:28'!
rootForGrabOf: aMorph
	"I act like a parts bin; answer a new copy of the morph being extracted."

	| v |
	v _ aMorph ownerThatIsA: ObjectElementMorph.
	v ifNotNil: [^v fullCopy].

	(owner isKindOf: MethodElementMorph)
		ifTrue: [^owner rootForGrabOf: aMorph].
	^owner! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
varColor
	| oc |
	oc _ owner color.
	^Color
		h: oc hue s: 0.5 v: 0.5
"	^owner color mixed: 0.93 with: Color black"! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:35'!
variableNames
	^variables collect: [:m| m name ]! !


PaletteElementMorph subclass: #MessageHeaderElementMorph
	instanceVariableNames: 'selector labels arguments '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 21:53'!
asSmalltalk
	| kw ws |
	kw _ selector keywords.
	ws _ WriteStream on: String new.
	1 to: kw size do: [:i|
		ws nextPutString: (kw at: i).
		(variables size < i) ifFalse: [
			ws nextPutString: ' ', (variables at: i) asSmalltalk, ' ' ]].
	^ws contents! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 23:06'!
beBinary
	self selector: selector arguments: #(arg)! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 23:07'!
contextMenu
	|m|
	m _ CustomMenu new.
	m add: 'rename...' action: #editSelector.
	arguments isEmpty ifTrue: [
		m add: 'add argument' action: #beBinary ].
	^m! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:05'!
editSelector
	|ans parms tokens|

	parms _ OrderedCollection new.
	ans _ FillInTheBlank request: 'selector:' initialAnswer: selector.
	ans isEmpty ifTrue: [^self].
	ans _ (SyntaxElementMorph selectorFrom: ans) asString.
	(ans includes: ($:)) ifFalse: [
		^self selector: ans arguments: #() ].

	tokens _ ans findTokens: ':'.
	1 to: tokens size do: [:i |
		parms add: 'arg', i printString ].

	self selector: ans arguments: parms.! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 00:31'!
fit
	| cw bw bw2 x arg lb maxHeight |

	labels ifNil: [^self].
	cw _ (self labelFont widthOf: $ ) // 2.
	bw _ self borderWidth.
	bw2 _ bw * 2.

	x _ self left + bw.
	maxHeight _ self labelFont height.

	1 to: labels size do: [:i |
		lb _ labels at: i.
		lb position: x @ self center y.
		x _ lb right + cw.
		(variables size >= i)
			ifTrue: [
				arg _ variables at: i.
				maxHeight _ maxHeight max: arg height.
				arg position: x @ self center y.
				x _ arg right + cw]].

	self extent: (x - self position x - cw - bw2) @ maxHeight + (bw2 * 2).
	variables do: [:each|
		each position: (each position x @ (bounds center y - (each height // 2))) ].
	labels do: [:each|
		each position: (each position x @ (bounds center y - (each height // 2))) ].

	(owner respondsTo: #fit)
		ifTrue: [^owner fit]! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 00:11'!
initialize
	super initialize.
	labels _ OrderedCollection new.
	variables _ OrderedCollection new.
	self fit! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 00:14'!
labelColor
	^Color black! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 23:39'!
labelFont
	^StrikeFont fontName: 'VerdanaBold' size: 10! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:13'!
selector
	^selector! !

!MessageHeaderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 22:53'!
selector: aString arguments: anArray

	"for decompilation purposes only. Caution: this method assumes that the number of arguments matches the
	number of parameters required by the selector."
	| tokens lb arg |

	selector _ aString.

	label ifNotNil: [label delete. label _ nil].
	labels do: [:each| each delete ].
	labels _ OrderedCollection new.
	arguments _ anArray.
	variables do: [:each| each delete ].
	variables _ OrderedCollection new.

	tokens _ selector findTokens: ':'.
	1 to: tokens size do: [:i |
		lb _ ((StringMorph 
				contents: (self wordsFrom: (tokens at: i)) 
				font: self labelFont) 
				color: self labelColor).
		labels add: lb.
		self addMorph: lb.
		(anArray size < i) ifFalse: [
			arg _ ObjectElementMorph new label: (anArray at: i) asString.
			arg color: owner color twiceDarker.
			variables add: arg.
			self addMorph: arg]].

	self fit
! !


SyntaxElementMorph subclass: #StepElementMorph
	instanceVariableNames: 'expression next oldColor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/9/2009 14:50'!
acceptDroppingMorph: aMorph event: evt

	self next: aMorph! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 22:35'!
addExpression
	expression _ ArgumentElementMorph new.
"	expression color: color muchLighter."
	self addMorphFront: expression.! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/19/2009 22:06'!
addToLast: anElement
	self stack last next: anElement! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 02:25'!
asSmalltalk
	expression ifNotNil: [^expression asSmalltalk]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/9/2009 14:02'!
borderWidth
	^1
! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/27/2009 23:02'!
contextMenu
	|m|
	m _ CustomMenu new.
"	m add: 'duplicate' action: #duplicate. "
	m add: 'delete' action: #throwAway.
	m addLine.
	m add: 'show code...' action: #showGeneratedSmalltalk.
	m add: 'show result...' action: #showResult.
	m add: 'evaluate' action: #evaluate.
	^m! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 20:26'!
drawOn: aCanvas 

	|r bw indent dent bw2 bw3 |
	bw _ self borderWidth.
	bw2 _ bw * 2.
	bw3 _ bw * 3.
	indent _ bw * 5.
	dent _ bw * 5.

	"border"
	"top"
	r _ Rectangle origin: ((self left + bw) @ self top) corner: (self left + indent) @ (self top + bw).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	r _ Rectangle origin: ((self left + indent - bw) @ (self top + bw)) corner: (self left + indent) @ (self top + bw3).
	aCanvas fillRectangle: r color: self borderColorDark.

	r _ Rectangle origin: ((self left + indent) @ (self top + bw2)) corner: (self left + indent + dent + bw) @ (self top + bw3).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	r _ Rectangle origin: ((self left + indent + dent) @ (self top)) corner: (self left + indent + dent + bw) @ (self top + bw2).
	aCanvas fillRectangle: r color: self borderColorLight.

	r _ Rectangle origin: ((self left + indent + dent + bw) @ (self top)) corner: (self right) @ (self top + bw).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	"left"
	r _ Rectangle origin: (self topLeft) corner: (self left + bw) @ (self bottom - bw3).
	aCanvas fillRectangle: r color: self borderColorLight.

	"right"
	r _ Rectangle origin: ((self right - bw) @ (self top + bw)) corner: (self right @ (self bottom - bw2)).
	aCanvas fillRectangle: r color: self borderColorDark.

	"bottom"
	r _ Rectangle origin: (self left @ (self bottom - bw3)) corner: (self left + indent) @ (self bottom - bw2).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	r _ Rectangle origin: (self left + indent) @ (self bottom - bw3) corner: (self left + indent + bw) @ (self bottom - bw).
	aCanvas fillRectangle: r color: self borderColorLight.

	r _ Rectangle origin: (self left + indent) @ (self bottom - bw) corner: (self left + indent + dent - bw) @ (self bottom).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	r _ Rectangle origin: (self left + indent + dent - bw) @ (self bottom - bw2) corner: (self left + indent + dent) @ (self bottom).
	aCanvas fillRectangle: r color: self borderColorDark.

	r _ Rectangle origin: (self left + indent + dent - bw) @ (self bottom - bw3) corner: (self right - bw) @ (self bottom - bw2).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	"body"
"	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw3) corner: (self right - bw) @ (self bottom - bw3)) color: color."

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw3) corner: (self right - bw) @ (self center y - bw)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y - bw) corner: (self right - bw) @ (self center y)) color: color lighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y) corner: (self right - bw) @ (self bottom - bw3)) color: color.


	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw) corner: (self left + indent - bw) @ (self top + bw3)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + indent + dent + bw) @ (self top + bw) corner: (self right - bw) @ (self top + bw3)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + indent + bw) @ (self bottom - bw3) corner: (self left + indent + dent - bw) @ (self bottom - bw)) color: color.
! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/4/2009 01:44'!
expression
	^expression contents! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/19/2009 22:38'!
expression: anElement
	expression contents: anElement! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 22:27'!
fit

	| cw handle bw x y|
	bw _ self borderWidth.
	cw _ self labelFont widthOf: $ .
	handle _ cw * 3.

	self width: expression width  + handle + (bw * 3).
	self height: expression height + (bw * 7).


	x _ self left + bw + handle.
	y _ (bounds center - (expression extent // 2)) y.

	expression position: x @ y.

	next isNil ifFalse:[
		next position: self left @ (self bottom - (self borderWidth * 2))].

	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:16'!
handlesMouseOverDragging: evt
	"Return true if I want to receive mouseEnterDragging: and mouseLeaveDragging: when the hand drags something over me (button up or button down), or when the mouse button is down but there is no mouseDown recipient. The default response is false; subclasses that implement mouse mouseEnterDragging messages should override this to return true."

	"NOTE:  If the hand state matters in these cases, it may be tested by constructs such as
		event anyButtonPressed
		event hand hasSubmorphs"

	^ true
! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 23:14'!
hilite

	oldColor _ color.
	self color: Color white.
	self allOwners do: [:each|
		(each isKindOf: StepElementMorph)
			ifTrue: [each unHilite ]]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/9/2009 14:40'!
initialize
	super initialize.
	color _ Color lightGreen twiceDarker.
	self addExpression.
	self fit.! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 22:50'!
isLast
	^next isNil! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/9/2009 14:02'!
labelFont
	^StrikeFont fontName: 'Verdana' size: 10! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 22:51'!
last
	self isLast
		ifTrue: [^self]
		ifFalse: [^next last]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:59'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event. The mouse just entered my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	| m |
	evt hand hasSubmorphs ifFalse: [^self].
	m _ evt hand submorphs first.
	(self wantsDroppedMorph: m event: evt)
		ifTrue: [
			self hilite ].! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:40'!
mouseLeaveDragging: evt
	"Handle a mouseLeaveLaden event. The mouse just left my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	self unHilite! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 23:08'!
next
	^next! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:42'!
next: anElement
	next _ anElement.
	self addMorphFront: next.
	self fit.
	self unHilite! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 23:26'!
removeNext
	| holder |
	next ifNotNil: [next _ nil ].
	holder _ self ownerThatIsA: StepHolderElementMorph.
	holder ifNotNil: [holder fit]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/30/2009 07:25'!
representsNil

	^self isLast & expression contents isNil! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 23:09'!
stack
	| list step |
	list _ OrderedCollection with: self.
	step _ self.
	[step next notNil] whileTrue: [
		step _ step next.
		list add: step ].
	^list
	! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 23:21'!
stackExtent
	| w h |
	w _ self width.
	h _ 0.
	self stack do: [:each|
		w _ w max: each width.
		h _ h + each height].
	h _ h - ((self borderWidth * 2) * (self stack size -1)).
	^w@h! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 00:41'!
unHilite

	oldColor ifNotNil: [
		self color: oldColor]! !

!StepElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:52'!
wantsDroppedMorph: aMorph event: evt

	^next isNil & (aMorph isKindOf: self class) & (self ownerThatIsA: ElementPaletteMorph) isNil
! !


StepElementMorph subclass: #PrimitiveElementMorph
	instanceVariableNames: 'textBox '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!PrimitiveElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/18/2009 22:54'!
addExpression
	expression _ TextBoxElementMorph new label: 'primitive '.
	self addMorphFront: expression.! !

!PrimitiveElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 02:19'!
asSmalltalk
	^'<',expression contents, '>'
! !

!PrimitiveElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/18/2009 22:58'!
contents: aString
	expression label: aString! !

!PrimitiveElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/18/2009 23:13'!
initialize
	super initialize.
	color _ Color yellow darker! !

!PrimitiveElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/19/2009 16:47'!
wantsDroppedMorph: aMorph event: evt

	^next isNil & (aMorph isKindOf: StepElementMorph)! !


StepElementMorph subclass: #ReturnElementMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!ReturnElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 20:21'!
addLabel
	label _ StringMorph contents: ' ^' font: self labelFont.
	label color: self labelColor.
	self addMorphFront: label.
! !

!ReturnElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 01:43'!
asSmalltalk
	^'^ ',super asSmalltalk! !

!ReturnElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 23:01'!
drawOn: aCanvas 

	|r bw indent dent bw2 bw3 |
	bw _ self borderWidth.
	bw2 _ bw * 2.
	bw3 _ bw * 3.
	indent _ bw * 5.
	dent _ bw * 5.

	"border"
	"top"
	r _ Rectangle origin: ((self left + bw) @ self top) corner: (self left + indent) @ (self top + bw).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	r _ Rectangle origin: ((self left + indent - bw) @ (self top + bw)) corner: (self left + indent) @ (self top + bw3).
	aCanvas fillRectangle: r color: self borderColorDark.

	r _ Rectangle origin: ((self left + indent) @ (self top + bw2)) corner: (self left + indent + dent + bw) @ (self top + bw3).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	r _ Rectangle origin: ((self left + indent + dent) @ (self top)) corner: (self left + indent + dent + bw) @ (self top + bw2).
	aCanvas fillRectangle: r color: self borderColorLight.

	r _ Rectangle origin: ((self left + indent + dent + bw) @ (self top)) corner: (self right) @ (self top + bw).
	aCanvas fillRectangle: r color: self borderColorVeryLight.


	"left"
	r _ Rectangle origin: (self topLeft) corner: (self left + bw) @ (self bottom - bw3).
	aCanvas fillRectangle: r color: self borderColorLight.

	"right"
	r _ Rectangle origin: ((self right - bw) @ (self top + bw)) corner: (self right @ (self bottom - bw2)).
	aCanvas fillRectangle: r color: self borderColorDark.

	"bottom"
	r _ Rectangle origin: (self left @ (self bottom - bw3)) corner: (self right - bw) @ (self bottom - bw2).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	"body"
"	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw3) corner: (self right - bw) @ (self bottom - bw)) color: Color red."

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw3) corner: (self right - bw) @ (self center y - bw)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y - bw) corner: (self right - bw) @ (self center y)) color: color lighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y) corner: (self right - bw) @ (self bottom - bw3)) color: color.


	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw) corner: (self left + indent - bw) @ (self top + bw3)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + indent + dent + bw) @ (self top + bw) corner: (self right - bw) @ (self top + bw3)) color: color twiceLighter.

! !

!ReturnElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/12/2009 21:04'!
fit

	| cw bw y|
	label ifNil: [^self].
	bw _ self borderWidth.
	cw _ self labelFont widthOf: $ .

	self width: expression width + label width + cw + (bw * 3).
	self height: expression height + (bw * 7).


	label position: (self left + bw) @ (bounds center - (label extent // 2)) y.

	expression position: (label right + cw) @ (bounds center - (expression extent // 2)) y.

	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!ReturnElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 23:02'!
initialize
	super initialize.
	color _ Color red twiceDarker.
	self addLabel.
	self fit.! !

!ReturnElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 22:28'!
wantsDroppedMorph: aMorph event: evt

	^false! !


ArgumentElementMorph subclass: #StepHolderElementMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!StepHolderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/23/2009 02:24'!
asSmalltalk
	|stack ws|
	contents ifNil: [^''].
	stack _ contents stack.
	ws _ WriteStream on: String new.
	stack do: [:eachStep|
		ws nextPutString: eachStep asSmalltalk.
		(eachStep == stack last)
			ifFalse: [ws nextPut: $.;cr]].
	^ws contents! !

!StepHolderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 22:04'!
drawOn: aCanvas 

	|r bw indent dent bw2 bw3 |

"	contents ifNotNil: [^aCanvas fillRectangle: self bounds color: owner color]."
	bw _ self borderWidth.
	bw2 _ bw * 2.
	bw3 _ bw * 3.
	indent _ bw * 5.
	dent _ bw * 5.

	"border"
	"top"
	r _ Rectangle origin: ((self left + bw) @ self top) corner: (self left + indent + bw) @ (self top + bw).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	r _ Rectangle origin: ((self left + indent) @ (self top + bw)) corner: (self left + indent + bw) @ (self top + bw3).
	aCanvas fillRectangle: r color: self borderColorLight.

	r _ Rectangle origin: ((self left + indent + bw) @ (self top + bw2)) corner: (self left + indent + dent + bw) @ (self top + bw3).
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	r _ Rectangle origin: ((self left + indent + dent) @ (self top)) corner: (self left + indent + dent + bw) @ (self top + bw2).
	aCanvas fillRectangle: r color: self borderColorDark.

	r _ Rectangle origin: ((self left + indent + dent + bw) @ (self top)) corner: (self right) @ (self top + bw).
	aCanvas fillRectangle: r color: self borderColorVeryDark.


	"left"
	r _ Rectangle origin: (self topLeft) corner: (self left + bw) @ (self bottom - bw3).
	aCanvas fillRectangle: r color: self borderColorDark.

	"right"
	r _ Rectangle origin: ((self right - bw) @ (self top + bw)) corner: (self right @ (self bottom - bw2)).
	aCanvas fillRectangle: r color: self borderColorLight.

	"bottom"
	r _ Rectangle origin: (self left @ (self bottom - bw3)) corner: (self right - bw) @ (self bottom - bw2).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

"	r _ Rectangle origin: (self left @ (self bottom - bw3)) corner: (self left + indent) @ (self bottom - bw2).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	r _ Rectangle origin: (self left + indent) @ (self bottom - bw3) corner: (self left + indent + bw) @ (self bottom - bw).
	aCanvas fillRectangle: r color: self borderColorDark.

	r _ Rectangle origin: (self left + indent) @ (self bottom - bw) corner: (self left + indent + dent - bw) @ (self bottom).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	r _ Rectangle origin: (self left + indent + dent - bw) @ (self bottom - bw2) corner: (self left + indent + dent) @ (self bottom).
	aCanvas fillRectangle: r color: self borderColorLight.

	r _ Rectangle origin: (self left + indent + dent - bw) @ (self bottom - bw3) corner: (self right - bw) @ (self bottom - bw2).
	aCanvas fillRectangle: r color: self borderColorVeryLight.
"
	"body"
	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw3) corner: (self right - bw) @ (self bottom - bw3)) color: color.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self top + bw) corner: (self left + indent) @ (self top + bw3)) color: color.

	aCanvas fillRectangle: (Rectangle origin: (self left + indent + dent + bw) @ (self top + bw) corner: (self right - bw) @ (self top + bw3)) color: color.

"	aCanvas fillRectangle: (Rectangle origin: (self left + indent + bw) @ (self bottom - bw3) corner: (self left + indent + dent - bw) @ (self bottom - bw)) color: color."
! !

!StepHolderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:55'!
fit
	| h |

	(owner isKindOf: MethodElementMorph) & (self ownerThatIsA: ElementsMethodEditorMorph) notNil
		ifTrue: [ ^self fitMethod ].

	contents isNil
		ifTrue: [
			h _ MessageElementMorph labelFont height.
			self extent: (h * 1.8) @ (h * 1.2)]
		ifFalse: [
			(owner isKindOf: MethodElementMorph).
			self extent: contents stackExtent  + (self borderWidth * 2).
			contents position: bounds center - (contents stackExtent // 2) ].
	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!StepHolderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 20:20'!
fitMethod
	| h |
	h _ MessageElementMorph labelFont height.
	self extent: (h * 1.8) @ (h * 1.2).
	contents ifNotNil: [
		contents position: self position + self borderWidth].
	(owner respondsTo: #fit)
		ifTrue: [owner fit]! !

!StepHolderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 10:53'!
mouseEnterDragging: evt
	"Handle a mouseEnterDragging event. The mouse just entered my bounds with a button pressed or laden with submorphs. This default implementation does nothing."

	| m |
	evt hand hasSubmorphs ifFalse: [^self].
	m _ evt hand submorphs first.
	(self wantsDroppedMorph: m event: evt)
		ifTrue: [
			self extent: m stackExtent  + (self borderWidth * 2).
			self hilite .
			(owner respondsTo: #fit)
			ifTrue: [owner fit]]! !

!StepHolderElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/5/2009 20:52'!
wantsDroppedMorph: aMorph event: evt

	^contents isNil & (aMorph isKindOf: StepElementMorph) & (self ownerThatIsA: ElementPaletteMorph) isNil

! !


ArgumentElementMorph subclass: #TextBoxElementMorph
	instanceVariableNames: 'doResizing insetX heightPadding stringMorph insetY selectionColor selectionEnd selectionStart undoState blinkState lastContents isKeyboardFocus acceptWhenFocusLost frame isNumeric client dragStartIndex isEditable '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 23:53'!
contents
	^label contents! !

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 20:37'!
fit
	label ifNil: [^self ].
	self extent: label extent + (self borderWidth * 2).
	self width: (self width + (self labelFont widthOf: $ )).
	label position: bounds center - (label extent // 2).
	(owner respondsTo: #fit)
		ifTrue: [owner fit]
! !

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 20:43'!
handlesMouseDown: evt
	"Return true if this morph wants to receive mouseDown events (i.e., mouseDown:, mouseMove:, mouseUp:). The default response is false; subclasses that implement mouse messages should override this to return true." 

	^ true
! !

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 22:16'!
initialize
	super initialize.
	color _ Color white.
	self fit! !

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 21:09'!
label: aString
	label ifNil: [
		label _ StringElementMorph contents: aString font: self labelFont.
		label color: self labelColor.
		self addMorphFront: label ].
	label contents: aString.
	self fit
! !

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 20:34'!
labelColor
	^Color black! !

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 22:14'!
labelFont
	^StrikeFont fontName: 'Verdana' size: 9! !

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 21:15'!
layoutChanged

	super layoutChanged.
	self resizeToLabel.! !

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 20:46'!
mouseDown: evt
	"Handle a mouse down event. This default implementation does nothing."
	label launchMiniEditor: evt! !

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 21:25'!
resizeToLabel
	| le h ne |
	label ifNil: [^self ].

	le _ (label extent + (self borderWidth * 2) + ((self labelFont widthOf: $ ) @ 0)).
	h _ MessageElementMorph labelFont height.
	ne _ ( h max: le x ) @ ( h max: le y).
	(self extent = ne) ifFalse: [self extent: ne ].

	(owner respondsTo: #fit)
		ifTrue: [owner fit]
! !

!TextBoxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 22:19'!
wantsDroppedMorph: aMorph event: evt

	^false! !
