LambdaBlockMorph subclass: #ReporterScriptBlockMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!ReporterScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 3/25/2010 15:09'!
drawOn: aCanvas

	super drawOn: aCanvas.
	self drawSlotBorderOn: aCanvas! !

!ReporterScriptBlockMorph methodsFor: 'drawing' stamp: 'jens 3/25/2010 15:13'!
drawSlotBorderOn: aCanvas

	(argMorphs first isKindOf: SpecialArgMorph)
		ifFalse: [^ self].

	aCanvas paintImage: (argMorphs first imageForm outlineEmbeddedAdjustedColor: color)
				at: argMorphs first position - 1


! !


!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:43'!
addItem
	| varBlock pos pname |
	super addItem.
	pos _ (argMorphs reject: [:m | m == self nextBlock]) size.
	(self isKindOf: CommandScriptBlockMorph)
		ifFalse: [pos _ pos - 1 ].
	pname _ ('#', pos printString) asUTF8.
	varBlock _ VariableBlockMorph new.
	varBlock 
		isSpecialForm: true;
		receiver: initialFrame;	
		selector: #getVar:;
"		color: (ScriptableScratchMorph blockColorFor: 'variables');"
		commandSpec: pname.
	(self isKindOf: CommandScriptBlockMorph)
		ifTrue: [ self replaceArgMorph: (self argumentAt: pos) by: varBlock ]
		ifFalse: [ self replaceArgMorph: (self argumentAt: pos + 1) by: varBlock].
	parameters add: pname.
	initialFrame add: pname
! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 8/2/2010 21:42'!
addRemove
	| varBlock pos |
	super removeItem.

	pos _ (argMorphs reject: [:m | m == self nextBlock]) size.
	(self isKindOf: CommandScriptBlockMorph)
		ifFalse: [pos _ pos - 1 ].
	varBlock _ VariableBlockMorph new.
	varBlock 
		isSpecialForm: true;
		receiver: nil;	
		selector: #getBlockVar:;
"		color: (ScriptableScratchMorph blockColorFor: 'variables');"
		commandSpec: '#', pos printString.
	(self isKindOf: CommandScriptBlockMorph)
		ifTrue: [ self replaceArgMorph: (self argumentAt: pos) by: varBlock ]
		ifFalse: [ self replaceArgMorph: (self argumentAt: pos + 1) by: varBlock]! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 5/17/2010 00:40'!
adjustInternals
	"private"

	| newSelector sdict newSpec |
	(#(function functionWithArgs) includes: selector) ifFalse: [^ self ].

	argMorphs size > 1 
		ifTrue: [
			sdict _ Dictionary new
				at: #function put: #functionWithArgs;
				yourself]
		ifFalse: [
			sdict _ Dictionary new
				at: #functionWithArgs put: #function;
				yourself].

	receiver ifNil: [^ self ].
	newSelector _ sdict at: selector ifAbsent: [selector].
	newSelector = selector ifTrue: [^ self].
	selector _ newSelector.

	newSpec _ self receiver blockSpecForSelector: selector.
	newSpec _ newSpec asMacRoman localized.

	self commandSpec: newSpec.
! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 11/4/2009 21:54'!
args
	^argMorphs! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 23:22'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	| blockTuple arg argList |
	blockTuple _ Array new: argMorphs size + 9.
	blockTuple
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: selector;
		at: 4 put: parameters asArray;
		at: 5 put: variables asArray;
		at: 6 put: type;
		at: 7 put: declarations;
		at: 8 put: isAtomic.

	argList _ argMorphs.
	argList _ self organizeArgs: argList.
	1 to: argList size do: [:i |
		arg _ argList at: i.
		(arg isKindOf: ArgMorph)
			ifTrue: [blockTuple at: i + 8 put: arg evaluate]
			ifFalse: [blockTuple at: i + 8 put: arg asBlockTuple]].

	^ blockTuple
! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/1/2011 15:47'!
body
	(argMorphs first isKindOf: BlockMorph)
		ifTrue: [^ argMorphs first fullCopy].
	^ nil! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 9/14/2010 22:20'!
deleteVariableTemplate: aVarBlockMorph

	aVarBlockMorph delete.
	argMorphs remove: aVarBlockMorph.
	self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3)! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/8/2010 00:10'!
helpScreenName
	"Answer the name of the help screen for this hat block, or nil if no help is available."

	^'reporterLambda'! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'JM 9/8/2011 15:45'!
indexForParameterName: aName

	^ parameters indexOf: aName ifAbsent: [ ^ nil ].
	 	! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/4/2010 21:09'!
initialize

	super initialize.
	type _ #any
! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/24/2010 23:10'!
isBooleanFunction
	^ isBoolean! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2010 00:18'!
isFunction
	^ true! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 02:36'!
nestedBlock
	^self args first! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/1/2010 20:33'!
optimized
	| newBlock reportBlock sel body a rcv |

	rcv _ self receiver.
	rcv ifNil: [rcv _ ScriptableScratchMorph new].
	(#(function #autoBlock) includes: selector)
		ifTrue: [sel _ #procedure]
		ifFalse: [sel _ #procedureWithArgs].
	newBlock _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: sel) 
							color: (ScriptableScratchMorph blockColorFor: 'operators').

	newBlock isAtomic: (isAtomic or: [self isKindOf: OSlotMorph]).

	reportBlock _ rcv blockFromSpec: (rcv wholeBlockSpecForSelector: #doAnswer) 
							color: (ScriptableScratchMorph blockColorFor: 'control').

	body _ self body.
	body ifNotNil:[
		reportBlock replaceArgMorph: (reportBlock argMorphs first) by: body].

	2 to: argMorphs size - 1 do: [:i |
		newBlock addItem ].

	2 to: argMorphs size do: [:i |
		a _ (argMorphs at: i) fullCopy.
		newBlock replaceArgMorph: (newBlock argMorphs at: i - 1) by: a ].

	newBlock attachBlock: reportBlock.
	newBlock parameters: parameters.
	newBlock variables: variables.
	newBlock fixInitialFrame.
	^newBlock! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/15/2010 01:32'!
privateBody
	"no copy"
	(argMorphs first isKindOf: BlockMorph)
		ifTrue: [^ argMorphs first].
	^ nil! !

!ReporterScriptBlockMorph methodsFor: 'as yet unclassified' stamp: 'jens 12/17/2009 03:03'!
removeItem
	argMorphs size > self minArgs ifTrue: [
		self removeLastArg.
		self commandSpec: (commandSpec copyFrom: 1 to: commandSpec size - 3) ]! !
