package enchanting;

import lejos.nxt.ColorSensor;
import lejos.nxt.SensorPort;

public class EnchantingColorLightSensor extends ColorSensor implements EnchantingColorOrLightSensor
{
	public EnchantingColorLightSensor(SensorPort port) { super(port, Color.WHITE); }
	/* public EnchantingColorLightSensor(SensorPort port, int type) { super(port, type); } */
	public int getUncalibratedValue() { return getRawLightValue(); }

	public int getCalibratedValue() { 
		//return readValue(); 
		int hundred = getHigh();
		int zero = getLow();
		if(hundred == zero) return 0;
		return 100 * (getRawLightValue() - zero) / (hundred - zero); 
	}

	public void setLampColor(EObject HSVlist) {
		HSV color = HSVlist.asHSV();
		if (color.isValid()) {
			if (color.val <= 35.0f) {
				this.setFloodlight(Color.NONE);
			} else if (color.sat <= 35.0f) {
				this.setFloodlight(Color.WHITE);
			} else if (color.hue > 300.0f || color.hue <= 60.0f) {
				this.setFloodlight(Color.RED);
			} else if (color.hue <= 180) {
				this.setFloodlight(Color.GREEN);
			} else {
				this.setFloodlight(Color.BLUE);
			}
		}
	}
	
	public EObject readColor() {
		ColorSensor.Color c = this.getColor();
		return EObject.createHSVListFromRGB(c.getRed(), c.getGreen(), c.getBlue());
	}
}