package enchanting;

import lejos.nxt.addon.ColorHTSensor;
import lejos.nxt.SensorPort;
import lejos.robotics.Color;

class EnchantingHTColorSensor extends ColorHTSensor implements EnchantingColorOrLightSensor
{
	public EnchantingHTColorSensor(SensorPort port) { super(port); low = 0; high = 255;}
	
	public void setLampColor(EObject HSVlist) { } // lamp is always on?
	
	public EObject readColor() {
		return EObject.createHSVListFromRGB(
			getRGBComponent(Color.RED), 
			getRGBComponent(Color.GREEN), 
			getRGBComponent(Color.BLUE));
	}	
	
	public int getCalibratedValue() {
		int hundred = high;
		int zero = low;
		if (hundred == zero) return 0;
		return 100 * (getUncalibratedValue() - zero) / (hundred - zero); 
	}
	
	public int getUncalibratedValue() {
		return getRGBComponent(Color.RED);
	}
	
	public int getHigh() { return high; }
	public int getLow()  { return low; }
	public void setHigh(int h) { high = h; }
	public void setLow(int l)  { low = l; }
	
	private int high, low;
}